/*
 * Software License Agreement (BSD License)
 *
 * Copyright (c) 2010, Kyoto University and Honda Motor Co.,Ltd. All rights reserved.
 *
 * HARK was developed by researchers in Okuno Laboratory at the Kyoto University and 
 * Honda Research Institute Japan Co.,Ltd.
 *
 * Redistribution and use in source and binary forms, with or without modification, are 
 * permitted provided that the following conditions are met:
 *
 *  * Redistributions of source code must retain the above copyright notice, this list 
 *    of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice, this 
 *    list of conditions and the following disclaimer in the documentation and/or other 
 *    materials provided with the distribution.
 *  * Neither the name of Kyoto University and Honda Motor Co.,Ltd., Inc. nor the names 
 *    of its contributors may be used to endorse or promote products derived from this 
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
 * SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCI-
 * DENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSI-
 * NESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTR-
 * ACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "CvfdContours.h"
#include <iostream>

using namespace std;
using namespace FD;
   
DECLARE_TYPE(CvfdContours);
   
CvfdContours::CvfdContours() :
  m_nbContours(0)
  , m_firstContours(0)
{
      
}
   
CvfdContours::CvfdContours(const CvfdContours* contours)
{
  m_nbContours = contours->getNbContours();
  m_firstContours = contours->getFirstContours();
  m_contours = contours->getContours();	      
}   
   
CvfdContours::~CvfdContours()
{
      
}
   
   
/**Serialize (binary) the object to a stream*/
void CvfdContours::serialize(std::ostream &out) const
{
      
}
   
/**Unserialize (binary) the object from a stream*/
void CvfdContours::unserialize(std::istream &in)
{
      
}
   
/**Generic print function*/
void CvfdContours::printOn(std::ostream &out) const
{
  out << "CvfdContours ";
  out << &m_contours;		
}
   
/**Generic read function*/
void CvfdContours::readFrom(std::istream &in)
{
      
}
   
CvSeq*  CvfdContours::getContours() const
{
  return m_contours;
}
   
CvSeq*  CvfdContours::getFirstContours() const
{
  return m_firstContours;
}

int CvfdContours::getNbContours() const
{
  return m_nbContours;
}
   
void CvfdContours::setContours(CvSeq* contours)
{
  m_contours = contours;
}
   
void CvfdContours::setFirstContours(CvSeq* firstContours)
{
  m_firstContours = firstContours;
}
   
void CvfdContours::setNbContours(int nbContours)
{
  m_nbContours = nbContours;
}   
 
/*
  CvSeq* CvfdContours::cloneMemory(CvSeq* contour,CvMemStorage* storage, int v,int* h)
  {
  cout << "V = ";
  cout << v << endl;
  cout << "H = ";
  cout << h[v] << endl;
  CvSeq* CvSeqTemp =  contour->v_next;
  if (CvSeqTemp != 0)
  {
  v++;
  cloneMemory(CvSeqTemp,storage, v, h);
  }
  else
  {
  CvSeqTemp =  contour->h_next;
  if (CvSeqTemp != 0)
  {
  h[v] = h[v]++;
  cloneMemory(CvSeqTemp,storage, v, h);
  }
  else
  {
  int i;
  cout <<"SAVE" << endl;
  CvSeq* CvSeqFinal = cvCloneSeq(contour,storage);
  for (i=0;i<h[v] ;i++)
  {
  cout <<"SAVE" << endl;
  contour = contour->h_prev;
  CvSeqFinal = cvCloneSeq(contour,storage);
  }
            
  cout <<"trace 1" << endl;
            
  CvSeqTemp =  contour->v_prev;     
  cout <<"trace 2" << endl;
            
  if (CvSeqTemp != 0)
  {
  v--;
  cloneMemory(CvSeqTemp,storage, v, h);
  }
  cout <<"trace 3" << endl;
            
  return CvSeqFinal;           
  }
  }
      
  }
*/
